-- $Id: //depot/Projects/StarWars_Expansion/Run/Data/Scripts/AI/LandMode/TacticalMultiplayerBuildLandUnitsGeneric.lua#7 $
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
-- (C) Petroglyph Games, Inc.
--
--
--  *****           **                          *                   *
--  *   **          *                           *                   *
--  *    *          *                           *                   *
--  *    *          *     *                 *   *          *        *
--  *   *     *** ******  * **  ****      ***   * *      * *****    * ***
--  *  **    *  *   *     **   *   **   **  *   *  *    * **   **   **   *
--  ***     *****   *     *   *     *  *    *   *  *   **  *    *   *    *
--  *       *       *     *   *     *  *    *   *   *  *   *    *   *    *
--  *       *       *     *   *     *  *    *   *   * **   *   *    *    *
--  *       **       *    *   **   *   **   *   *    **    *  *     *   *
-- **        ****     **  *    ****     *****   *    **    ***      *   *
--                                          *        *     *
--                                          *        *     *
--                                          *       *      *
--                                      *  *        *      *
--                                      ****       *       *
--
--/////////////////////////////////////////////////////////////////////////////////////////////////
-- C O N F I D E N T I A L   S O U R C E   C O D E -- D O   N O T   D I S T R I B U T E
--/////////////////////////////////////////////////////////////////////////////////////////////////
--
--              $File: //depot/Projects/StarWars_Expansion/Run/Data/Scripts/AI/LandMode/TacticalMultiplayerBuildLandUnitsGeneric.lua $
--
--    Original Author: James Yarrow
--
--            $Author: James_Yarrow $
--
--            $Change: 56734 $
--
--          $DateTime: 2006/10/24 14:15:48 $
--
--          $Revision: #7 $
--
--/////////////////////////////////////////////////////////////////////////////////////////////////

require("pgevents")


function Definitions()
	
	Category = "Tactical_Multiplayer_Build_Land_Units_Generic"
	IgnoreTarget = true
	TaskForce = {
	{
		"ReserveForce"
		,"DenySpecialWeaponAttach"
		,"DenyHeroAttach"	
		,"RC_Level_Two_Tech_Upgrade | RC_Level_Three_Tech_Upgrade = 0,1"
		,"GRC_Level_Two_Tech_Upgrade | GRC_Level_Three_Tech_Upgrade = 0,1"
		,"EC_Level_Two_Tech_Upgrade | EC_Level_Three_Tech_Upgrade = 0,1"
		,"UC_Level_Two_Tech_Upgrade | UC_Level_Three_Tech_Upgrade = 0,1"		
		,"Boba_Fett_Team_Land_MP | Darth_Team_Land_MP | General_Veers_Team | Emperor_Palpatine_Team | Prince_Xizor_Team | Mara_Jade_Team = 0,1"
		,"Han_Solo_Team_Land_MP | Obi_Wan_Team | Droids_Team | Katarn_Team | Yoda_Team | Luke_Skywalker_Jedi_Team | Fordo_Team | Garm_Bel_Iblis_Team = 0,1"
		,"Urai_Fen_Team | Bossk_Team | Silri_Team | Tyber_Zann_Team | IG88_Team = 0,1"
		,"RN_Republic_Pod_Walker_Company | Republic_Pirate_Skiff_Team | Republic_Pirate_Swamp_Speeder_Team | Republic_Clonetrooper_Squad | Republic_AT-AP_Company | Republic_SPHA-T_Corps | Republic_Swamp_Speeder_Team | UT-AT_Company | Barc_Scout_Squad | AT-TE_Company = 0,3"
		,"Rebel_Speeder_Wing | Rebel_Artillery_Brigade | RN_Rebel_Pod_Walker_Company | Rebel_Pirate_Skiff_Team | Rebel_Pirate_Swamp_Speeder_Team | Rebel_Pod_Walker_Company | Rebel_Light_Tank_Brigade | Rebel_Heavy_Tank_Brigade | Rebel_Infantry_Squad | Rebel_Tank_Buster_Squad | Rebel_Infiltrator_Team = 0,3"
		,"EN_Imperial_Pod_Walker_Company | Empire_Pirate_Skiff_Team | Empire_Pirate_Swamp_Speeder_Team | Imperial_Stormtrooper_Squad | Imperial_Artillery_Corp | Imperial_Anti_Infantry_Brigade | Imperial_Armor_Group | Imperial_Heavy_Scout_Squad | Imperial_Heavy_Assault_Company | Imperial_Light_Scout_Squad | DarkTrooper_P1_Company | DarkTrooper_P2_Company | DarkTrooper_P3_Company | Noghri_Assassin_Squad = 0,3"
		,"AAT_Brigade | STAP_Squad | Destroyer_Droid_Company | Underworld_Super_Battledroid_Squad | Hailfire_Droid_Company | Underworld_Battledroid_Squad | Night_Sister_Company | Snail_Droid_Team | Underworld_Pod_Walker_Company | Underworld_Skiff_Team | Underworld_Swamp_Speeder_Team = 0,3"
		,"Republic_Gunship_Wing | Rebel_MDU_Company | Republic_MDU_Company = 0,1"
		,"HAV_Juggernaut_Company | Imperial_Sniper_Team | Imperial_Anti_Aircraft_Company | Empire_MDU_Company = 0,1"
		,"Vornskr_Wolf_Pack | MTT_Company | Underworld_MDU_Company = 0,1"
		}
	}
	RequiredCategories = {"Infantry | Vehicle | LandHero | Upgrade"}
	AllowFreeStoreUnits = false

end

function ReserveForce_Thread()
			
	ReserveForce.Set_Plan_Result(true)
	ReserveForce.Set_As_Goal_System_Removable(false)
	BlockOnCommand(ReserveForce.Produce_Force())

	-- Give some time to accumulate money.
	tech_level = PlayerObject.Get_Tech_Level()
	min_credits = 2000
	max_sleep_seconds = 30
	if tech_level == 2 then
		min_credits = 3000
		max_sleep_seconds = 45
	elseif tech_level >= 3 then
		min_credits = 4000
		max_sleep_seconds = 60
	end
	
	current_sleep_seconds = 0
	while (PlayerObject.Get_Credits() < min_credits) and (current_sleep_seconds < max_sleep_seconds) do
		current_sleep_seconds = current_sleep_seconds + 1
		Sleep(1)
	end
		
	ScriptExit()
end